<?php
// NB wordpress menu
function nb_admin_menu() {	
	if( (float)substr(get_bloginfo('version'), 0, 3) < 3.8) {
		$menu_img = NB_URL.'/img/nb_logo_small_old.png';
	} else {
		$menu_img = NB_URL.'/img/nb_logo_small.png';
	}
	$capability = 'edit_pages';
	
	add_menu_page('Swift Box', 'Swift Box', 'edit_pages', 'nb_menu', 'nb_builder', $menu_img, 56);
	add_submenu_page('nb_menu', esc_html__('Manage Boxes', 'nb_ml'), esc_html__('Manage Boxes', 'nb_ml'), $capability, 'nb_menu', 'nb_builder');
}
add_action('admin_menu', 'nb_admin_menu', 8);



// submeus after CPT
function nb_admin_late_menu() {	
	$capability = 'edit_pages';
	
	add_submenu_page('nb_menu', esc_html__('QN Categories', 'nb_ml'), esc_html__('QN Categories', 'nb_ml'), $capability, 'edit-tags.php?taxonomy=nb_news_cat');
	add_submenu_page('nb_menu', esc_html__('Settings', 'nb_ml'), esc_html__('Settings', 'nb_ml'), 'install_plugins', 'nb_settings', 'nb_settings');
}
add_action('admin_menu', 'nb_admin_late_menu', 25);



// management and builder
function nb_builder() { 
	include_once(NB_DIR . '/builder.php');
}

// settings
function nb_settings() {
	include_once(NB_DIR . '/settings/view.php');
}




////////////////////////////////////
// BOXES TAXONOMY

add_action( 'init', 'register_taxonomy_nb_boxes' );
function register_taxonomy_nb_boxes() {
    $labels = array( 
        'name' => esc_html__( 'Boxes', 'nb_ml'),
        'singular_name' => esc_html__( 'Box', 'nb_ml'),
        'search_items' => esc_html__( 'Search Boxes', 'nb_ml'),
        'popular_items' => esc_html__( 'Popular Boxes', 'nb_ml'),
        'all_items' => esc_html__( 'All Boxes', 'nb_ml'),
        'parent_item' => esc_html__( 'Parent Box', 'nb_ml'),
        'parent_item_colon' => esc_html__( 'Parent Box:', 'nb_ml'),
        'edit_item' => esc_html__( 'Edit Box', 'nb_ml'),
        'update_item' => esc_html__( 'Update Box', 'nb_ml'),
        'add_new_item' => esc_html__( 'Add New Box', 'nb_ml'),
        'new_item_name' => esc_html__( 'New Box', 'nb_ml'),
        'separate_items_with_commas' => esc_html__( 'Separate boxes with commas', 'nb_ml'),
        'add_or_remove_items' => esc_html__( 'Add or remove Boxes', 'nb_ml'),
        'choose_from_most_used' => esc_html__( 'Choose from most used Boxes', 'nb_ml'),
        'menu_name' => esc_html__( 'Boxes', 'nb_ml'),
    );

    $args = array( 
        'labels' => $labels,
        'public' => false,
        'show_in_nav_menus' => false,
        'show_ui' => false,
        'show_tagcloud' => false,
        'hierarchical' => false,
        'rewrite' => false,
        'query_var' => true
    );
    register_taxonomy('nb_boxes', null, $args);
}



////////////////////////////////////////////////////////////////////////



////////////////////////////////////
// NEWS CPT

add_action('init', 'register_cpt_nb_news');
function register_cpt_nb_news() {
    $labels = array( 
        'name' => esc_html__('Quick News', 'nb_ml'),
        'singular_name' => esc_html__('News', 'nb_ml'),
        'add_new' => esc_html__('Add New', 'nb_ml'),
        'add_new_item' => esc_html__('Add New News', 'nb_ml'),
        'edit_item' => esc_html__('Edit News', 'nb_ml'),
        'new_item' => esc_html__('New News', 'nb_ml'),
        'view_item' => esc_html__('View News', 'nb_ml'),
        'search_items' => esc_html__('Search News', 'nb_ml'),
        'not_found' => esc_html__('No news found', 'nb_ml'),
        'not_found_in_trash' => esc_html__('No news found in Trash', 'nb_ml'),
        'parent_item_colon' => esc_html__('Parent News:', 'nb_ml'),
        'menu_name' => esc_html__('Quick News', 'nb_ml'),
    );

    $args = array( 
        'labels' => $labels,
        'hierarchical' => false,
        'supports' => array('title', 'editor', 'thumbnail'),
        'taxonomies' => array('nb_news_cat'),
        'public' => false,
        'show_ui' => true,
        'show_in_nav_menus' => false,
        'publicly_queryable' => true,
        'exclude_from_search' => true,
        'has_archive' => false,
        'query_var' => true,
        'can_export' => true,
        'rewrite' => false,
        'capability_type' => 'post',
		'show_in_menu' => 'nb_menu'
    );
    register_post_type('nb_news', $args);
}

// customize messages
function nb_updated_messages( $messages ) {
  global $post;

  $messages['nb_news'] = array(
    0 => '', // Unused. Messages start at index 1.
    1 => esc_html__('News updated', 'nb_ml'),
    2 => esc_html__('News updated', 'nb_ml'),
    3 => esc_html__('News deleted', 'nb_ml'),
    4 => esc_html__('News updated', 'nb_ml'),
    /* translators: %s: date and time of the revision */
    5 => isset($_GET['revision']) ? sprintf( esc_html__('News restored to revision from %s', 'nb_ml'), wp_post_revision_title( (int) $_GET['revision'], false ) ) : false,
    6 => esc_html__('News published', 'nb_ml'),
    7 => esc_html__('News saved', 'nb_ml'),
    8 => esc_html__('News submitted', 'nb_ml'),
    9 => sprintf( esc_html__('News scheduled for: <strong>%1$s</strong>', 'nb_ml'), date_i18n( esc_html__( 'M j, Y @ G:i' ), strtotime( $post->post_date ))),
    10 => esc_html__('News draft updated', 'nb_ml'),
  );

  return $messages;
}
add_filter('post_updated_messages', 'nb_updated_messages');




////////////////////////////////////
// NEWS CATEGORY

add_action( 'init', 'register_taxonomy_nb_news_cat');
function register_taxonomy_nb_news_cat() {

    $labels = array( 
        'name' => esc_html__('QN Categories', 'nb_ml'),
        'singular_name' => esc_html__('QN Category', 'nb_ml'),
        'search_items' => esc_html__('Search QN Categories', 'nb_ml'),
        'popular_items' => esc_html__('Popular QN Categories', 'nb_ml'),
        'all_items' => esc_html__('All QN Categories', 'nb_ml'),
        'parent_item' => esc_html__('Parent QN Category', 'nb_ml'),
        'parent_item_colon' => esc_html__('Parent QN Category:', 'nb_ml'),
        'edit_item' => esc_html__('Edit QN Category', 'nb_ml'),
        'update_item' => esc_html__('Update QN Category', 'nb_ml'),
        'add_new_item' => esc_html__('Add New QN Category', 'nb_ml'),
        'new_item_name' => esc_html__('New QN Category', 'nb_ml'),
        'separate_items_with_commas' => esc_html__('Separate news categories with commas', 'nb_ml'),
        'add_or_remove_items' => esc_html__('Add or remove news categories', 'nb_ml'),
        'choose_from_most_used' => esc_html__('Choose from the most used news categories', 'nb_ml'),
        'menu_name' => esc_html__('QN Categories', 'nb_ml'),
    );

    $args = array( 
        'labels' => $labels,
        'public' => false,
        'show_in_nav_menus' => false,
        'show_ui' => true,
        'show_tagcloud' => false,
        'show_admin_column' => true,
        'hierarchical' => true,
        'rewrite' => false,
        'query_var' => true
    );

    register_taxonomy('nb_news_cat', array('nb_news'), $args);
}




//////////////////////////////////////
// customize the grid items custom post type table
add_filter('manage_edit-nb_news_columns', 'nb_edit_qn_table_head', 10, 2);
function nb_edit_qn_table_head($columns) {

	return $columns + array(
		'nb_link'	=> esc_html__('News Link', 'nb_ml'),
		'nb_media'	=> esc_html__('News Media', 'nb_ml'),
		'nb_thumb' 	=> esc_html__('Main Image', 'nb_ml')
	);
}


add_action('manage_nb_news_posts_custom_column', 'nb_edit_qn_table_body', 10, 2);
function nb_edit_qn_table_body($column_name, $id) {
	
	switch ($column_name) {

		case 'nb_link' :
		case 'nb_media' :
			$val = trim((string)get_post_meta($id, $column_name, true));
			
			echo '<a href="'. $val .'" target="_blank" title="'. $val .'" class="nb_qn_link">'. $val .'</a>';
			break;

		case 'nb_thumb' :
			echo get_the_post_thumbnail($id, array(110, 110));
			break;
	
		default :
			break;
	}
	return true;
}




//////////////////////////////////////
// fix to set the taxonomy as menu page sublevel
function nb_menu_correction($parent_file) {
	global $current_screen;

	// hack for taxonomy
	if(isset($current_screen->taxonomy)) {
		$taxonomy = 'nb_news_cat';
		if($taxonomy == $current_screen->taxonomy) {
			$parent_file = 'nb_menu';
		}	
	}
	
	return $parent_file;
}
add_action('parent_file', 'nb_menu_correction');





//////////////////////////////////////
// ENABLE CPT FILTER BY TAXONOMY

add_action('restrict_manage_posts','nb_qn_filter_by_cat');
function nb_qn_filter_by_cat() {
    global $typenow;
    global $wp_query;
	
    if ($typenow == 'nb_news') {
        $taxonomy = 'nb_news_cat';
		
		$sel = (isset($wp_query->query['nb_news_cat'])) ? $wp_query->query['nb_news_cat'] : ''; 
		
        wp_dropdown_categories(array(
            'show_option_all' =>  esc_html__("Any category", 'nb_ml'),
            'taxonomy'        =>  $taxonomy,
            'name'            =>  'nb_news_cat',
            'orderby'         =>  'name',
            'selected'        =>  $sel,
            'hierarchical'    =>  false,
            'depth'           =>  1,
            'show_count'      =>  false,
            'hide_empty'      =>  true
        ));
    }
}

add_filter('parse_query','nb_cat_id_to_cat_term');
function nb_cat_id_to_cat_term($query) {
	global $pagenow;
	
	$post_type = 'nb_news';
	$taxonomy  = 'nb_news_cat';
	
	$q_vars    = &$query->query_vars;
	if($pagenow == 'edit.php' && isset($q_vars['post_type']) && $q_vars['post_type'] == $post_type && isset($q_vars[$taxonomy]) && is_numeric($q_vars[$taxonomy]) && $q_vars[$taxonomy]) {
		
		$term = get_term_by('id', $q_vars[$taxonomy], $taxonomy);
		$q_vars[$taxonomy] = $term->slug;
	}
}



