<?php
// DEFINING MODULE STRUCTURE AND FIELDS


class nb_divi_module extends ET_Builder_Module {

	public $slug       = 'lcnb';
	public $vb_support = 'on';

    
	protected $module_credits = array(
        'module_uri' => 'https://lcweb.it/swift-box-wordpress-plugin',
        'author'     => 'LCweb',
        'author_uri' => 'https://lcweb.it/',
	);

    
    public function get_advanced_fields_config() {
        return unserialize(LC_DIVI_DEF_OPTS_OVERRIDE);
	}

    
	public function init() {
		$this->name               = 'Swift Box';
		$this->icon_path          = $GLOBALS['nb_divi_icon_path'];
		$this->main_css_element   = '%%order_class%%';	
        
        $this->settings_modal_toggles  = array(
			'general'  => array(
				'toggles' => array(
					'main' => esc_html__('Main Options', NB_ML),
				),
			),
		);
	}
 
    
	public function get_fields() {
        $fields =array(
            'box_id' => array(
                'toggle_slug'     => 'main',
				'label'           => esc_html__('Select a box', NB_ML),
				'type'            => 'select',
                'default'         => current(array_keys($GLOBALS['nb_boxes'])),
				'default_on_front'=> current(array_keys($GLOBALS['nb_boxes'])),
				'options'         => $GLOBALS['nb_boxes'],
				//'description'     => esc_html__( 'Choose whether your linklink opens in a new window or not', 'dicm-divi-custom-modules' ),
			),
		);
        
        
        $GLOBALS[ $this->slug .'_divi_field_indexes'] = array_keys($fields);
        return $fields;
	}


    
    public function render($attrs, $content = null, $render_slug) {
        return nb_divi_modules::front_shortcode_render($this->slug, $this->props);  
	}
}

new nb_divi_module;
