<?php
// INITIALIZE GUTEN BLOCKS AND DEFINE HANDLERS



// register blocks
function nb_guten_register() {
	if(!function_exists('register_block_type')) {return;}
	
	include_once(NB_DIR .'/functions.php');
	include_once('guten_elements/box.php');	
}
add_action('init', 'nb_guten_register');





// enqueue scripts in gutenberg 
function nb_guten_scripts() {
    global $current_screen;
    
    $deps = array(
        'wp-blocks',
        'wp-i18n',
        'wp-element',
    );  
    if($current_screen->base != 'widgets') {
        $deps[] = 'wp-editor';     
    }
    
    
	wp_enqueue_script(
		'lc_guten_toolkit',
		NB_URL .'/builders_integration/guten_elements/common.js',
		$deps,
		'1.2.2',
		true
	);
	
	
	wp_enqueue_script(
		'lcweb/swift-box',
		NB_URL .'/builders_integration/guten_elements/box.js',
		$deps,
		NB_VER, 
		true
	);
	
	
	// hook for additional scripts
	if(!did_action('lc_guten_scripts')) {
		$GLOBALS['lc_guten_scripts'] = true;
		do_action('lc_guten_scripts');
	}
}
add_action('enqueue_block_editor_assets', 'nb_guten_scripts');






// hook for custom scripts in gutenberg head
if(!function_exists('lc_scripts_in_guten_head')) {
	function lc_scripts_in_guten_head() {
		do_action('lc_scripts_in_guten_head');
	}
	add_action('admin_head', 'lc_scripts_in_guten_head', 999);
}







// remote handler for ServerSideRender blocks
function nb_guten_handler($atts) {
	$code = '';
	
	ob_start();
	nb_inline_css();
	$code .= ob_get_clean();

	// compile atts
	$compiled = array();
	foreach($atts as $key => $val) {
		$compiled[] = $key .'="'. esc_attr($val) .'"'; 	
	}
	
	return $code . do_shortcode('[swiftbox '. implode(' ', $compiled) .']');
}




// ajax handler to execute dynamic javascript code on box choice
function nb_guten_async_render() {
	echo do_shortcode('[swiftbox id="'. (int)$_POST['box_id'] .'"]');
	wp_die();
}
add_action('wp_ajax_nb_guten_async_render', 'nb_guten_async_render');




// fixes WP > 5.5 fields type declaration deprecation 
function nb_fix_block_defs($array) {
    foreach($array as $fid => $fdata) {
        $array[$fid]['lc_type'] = $array[$fid]['type'];
        $array[$fid]['type'] = ($array[$fid]['type'] == 'number') ? 'number' : 'string';    
    }
    
    return $array;
}
