<?php
// FIXED JAVASCRIPT VARIABLES TO BE PRINTED IN WEBSITE'S HEAD


function nb_head_js() {

	// dates localizations
	$dates_local = array(
		'short_d_names' => '["'. implode('", "', array(
			esc_html__('Sun', 'nb_ml'), esc_html__('Mon', 'nb_ml'), esc_html__('Tue', 'nb_ml'), esc_html__('Wed', 'nb_ml'), esc_html__('Thu', 'nb_ml'), esc_html__('Fri', 'nb_ml'), esc_html__('Sat', 'nb_ml')	
		)) .'"]',
		
		'full_d_names' => '["'. implode('", "', array(
			esc_html__('Sunday', 'nb_ml'), esc_html__('Monday', 'nb_ml'), esc_html__('Tuesday', 'nb_ml'), esc_html__('Wednesday', 'nb_ml'), esc_html__('Thursday', 'nb_ml'), esc_html__('Friday', 'nb_ml'), esc_html__('Saturday', 'nb_ml')	
		)) .'"]',
		
		'short_m_names' => '["'. implode('", "', array(
			esc_html__('Jan', 'nb_ml'), esc_html__('Feb', 'nb_ml'), esc_html__('Mar', 'nb_ml'), esc_html__('Apr', 'nb_ml'), esc_html__('May', 'nb_ml'), esc_html__('Jun', 'nb_ml'), esc_html__('Jul', 'nb_ml'), esc_html__('Aug', 'nb_ml'), esc_html__('Sep', 'nb_ml'), esc_html__('Oct', 'nb_ml'), esc_html__('Nov', 'nb_ml'), esc_html__('Dec', 'nb_ml')	
		)) .'"]',
		
		'full_m_names' => '["'. implode('", "', array(
			esc_html__('January', 'nb_ml'), esc_html__('February', 'nb_ml'), esc_html__('March', 'nb_ml'), esc_html__('April', 'nb_ml'), esc_html__('May', 'nb_ml'), esc_html__('June', 'nb_ml'), esc_html__('July', 'nb_ml'), esc_html__('August', 'nb_ml'), esc_html__('September', 'nb_ml'), esc_html__('October', 'nb_ml'), esc_html__('November', 'nb_ml'), esc_html__('December', 'nb_ml')
		)) .'"]',
		
		'elapsed_names' => '["'. implode('", "', array(
			esc_html__('ago', 'nb_ml'), esc_html__('seconds', 'nb_ml'), esc_html__('minute', 'nb_ml'), esc_html__('minutes', 'nb_ml'), esc_html__('hour', 'nb_ml'), esc_html__('hours', 'nb_ml'), esc_html__('day', 'nb_ml'), esc_html__('days', 'nb_ml'), esc_html__('week', 'nb_ml'), esc_html__('weeks', 'nb_ml'), esc_html__('month', 'nb_ml'), esc_html__('months', 'nb_ml')
		)) .'"]',
	);
	
    // strings localization
    $html_titles = '["'. implode('", "', 
        array(
			esc_html__('check original source', 'nb_ml'),
            esc_html__('expand text', 'nb_ml'),
            esc_html__('share', 'nb_ml'),
            esc_html__('share on Facebook', 'nb_ml'),
            esc_html__('share on Twitter', 'nb_ml'),
            esc_html__('share on Pinterest', 'nb_ml'),
		)
    ) .'"]';
    
	?>
    <script type="text/javascript">  
    (function($) { 
        "use strict"; 
        
        window.lcnb_glob_vars = {
            rss2json_token	: '<?php echo get_option('nb_rss2json_token') ?>',
            youtube_key	    : '<?php echo get_option('nb_youtube_key') ?>',
            theme 			: '<?php echo (get_option('nb_custom_style')) ? 'wpdt' : get_option('nb_main_style', 'minimal') ?>',
            preloader 		: <?php echo (get_option('nb_preloader', 1)) ? 'true' : 'false' ?>,
            lightbox 		: <?php echo (get_option('nb_lightbox', 1) || get_option('nb_exp_in_lb')) ? 'true' : 'false'; ?>, 
            touchswipe 		: <?php echo (get_option('nb_touchswipe')) ? 'true' : 'false'; ?>,
            min_news_h		: <?php echo (int)get_option('nb_min_news_h', 150) ?>,
            min_news_w 		: <?php echo (int)get_option('nb_min_news_w', 200) ?>,
            min_horiz_w 	: <?php echo (int)get_option('nb_min_horiz_w', 400) ?>,
            read_more_txt 	: <?php echo '"'.str_replace('"', '\"', get_option('nb_read_more_txt', '..')).'"' ?>,
            exp_in_lightbox : <?php echo (get_option('nb_exp_in_lb')) ? 'true' : 'false' ?>,
            exp_lb_w		: '<?php echo (int)get_option('nb_exp_lb_w', 90) ?>%',
            exp_lb_max_w	: <?php echo (int)get_option('nb_exp_lb_max_w', 1000) ?>,
            fb_share_fix	: <?php echo '"'.NB_URL.'/lcis_fb_img_fix.php"' ?>,
            script_basepath : <?php echo '"'.NB_URL.'/js/sb/"' ?>,
            scripts_man_added: true,

            short_d_names 	: <?php echo $dates_local['short_d_names'] ?>,
            full_d_names 	: <?php echo $dates_local['full_d_names'] ?>,
            short_m_names 	: <?php echo $dates_local['short_m_names'] ?>,
            full_m_names 	: <?php echo $dates_local['full_m_names'] ?>,
            elapsed_names 	: <?php echo $dates_local['elapsed_names'] ?>,

            html_titles     : <?php echo $html_titles ?>, 
        };
           
        <?php 

        // custom theme setup
        if(get_option('nb_custom_style') && (get_option('nb_inline_css') || get_option('nb_force_inline_css'))) : 
        ?>
        if(typeof(lcnb_loaded_themes) == 'undefined') {
            lcnb_loaded_themes = [];
        }
        lcnb_loaded_themes.push('wpdt');
    <?php endif; ?>
    })(jQuery);
	</script>
	<?php
}

add_action('wp_head', 'nb_head_js', 10);
add_action('lc_scripts_in_guten_head', 'nb_head_js');