<?php

// LC DASHBOARD
$baseurl = $GLOBALS['lcwpd_baseurl'];

$lic_class = new lcwpd_licenses();
$licenses = $lic_class->get_licenses($force_check = false);
?>
<div class="wrap lcwpd_wrap">
    <h1 id="lcwpd_main_head" class="wp-heading-inline">
        <img src="<?php echo $baseurl ?>/assets/img/logo.svg" alt="lcweb" />
        <span>Dashboard</span>
    </h1>  
    
    <div id="lcwpd_pre_list">
        <p><strong>Hello!</strong> This is a summary of LCweb products installed on the current domain (<em><?php echo lcwpd_licenses::ignore_www($_SERVER['HTTP_HOST']) ?></em>). To activate a license you must have registered it on the <strong><a href="https://licenses.lcweb.it" target="_blank">Licenses Hub <span class="dashicons dashicons-external"></span></a></strong></p>
        
        <ul>
            <li>Activating the license you will automatically enable <strong>plugins automated updater!</strong></li>
            <li><u>Soon</u> a validated license will be required to <strong>use the plugin</strong>. It's therefore suggested to apply as soon as you can</strong></li>
        </ul>

        <p id="lcwpd_useful_links"><small>
            <a href="mailto:quotation@lcweb.it" target="_blank">
                <span class="dashicons dashicons-superhero-alt"></span> need a customization?
            </a>
            <a href="https://support.lcweb.it/" target="_blank">
                <span class="dashicons dashicons-sos"></span> technical support
            </a>
            <a href="https://lcweb.it/lc-wp-dashboard-faqs" target="_blank">
                <span class="dashicons dashicons-format-status"></span> LCweb Dashboard FAQs
            </a>
        </small></p>
    </div>
    
    
    
    <h3>Enabled Plugins</h3>
    <ul class="lcwpd_prod_list lcwpd_owned_prods">
        <?php foreach(lcwpd_licenses::owned_products() as $prod_path => $pdata) : ?>
    
            <li class="lcwpd_prod" data-prod-id="<?php echo esc_attr($pdata['id']) ?>" data-prod-slug="<?php echo esc_attr($pdata['slug']) ?>">
                <div class="lcwpd_prod_firstblock">
                    <span>
                        <img src="<?php echo $baseurl ?>/assets/img/product_logos/<?php echo esc_attr($pdata['slug']) ?>.svg" alt="<?php echo esc_attr($pdata['name']) ?>" />
                    </span>

                    <div>
                        <h4>
                            <?php echo $pdata['name'] ?>
                            <a href="javascript:void(0)" class="dashicons dashicons-editor-ul lcwpd_changelog_trigger" title="view changelog"></a>
                            <a href="<?php echo esc_attr($pdata['doc_link']) ?>" target="_blank" class="dashicons dashicons-flag lcwpd_doc_link" title="view documentation"></a>
                        </h4>

                        <?php if(!lcwpd_licenses::supports_lc_dashboard($prod_path)) : ?>
                            <span class="lcwpd_update_to_use_warn">Please update the plugin to the latest version in order to integrate it here</span>

                        <?php else : ?>

                            <?php if(isset($licenses[ $pdata['id'] ])) : ?>
                                <form method="post" class="lcwpd_inserted_token_form form-wrap">
                                    <fieldset>
                                        <input type="text" name="lcwpd_inserted_token" value="<?php echo $licenses[ $pdata['id'] ]['tok'] ?>" disabled />
                                        <input type="button" name="lcwpd_change_token_btn" value="Change" class="button-secondary" />
                                    </fieldset>
                                </form>   
                            <?php endif; ?>

                            <form method="post" class="lcwpd_insert_token_form form-wrap <?php if(isset($licenses[ $pdata['id'] ])) echo 'lcwpd_displaynone' ?>">
                                <input type="text" name="lcwpd_prod_token" value="" placeholder="activation token" autocomplete="off" maxlength="32" required />
                                <input type="button" name="lcwpd_prod_activation_btn" value="Validate" class="button-secondary" />
                            </form>
                            
                            <?php 
                            if(!isset($licenses[ $pdata['id'] ])) {
                                echo '<a href="javascript:void(0)" class="lcwpd_how_get_token">How to get the token?</a>';
                            }
                        endif; ?>
                    </div>
                </div>
                
                <?php if(lcwpd_licenses::supports_lc_dashboard($prod_path) && isset($licenses[ $pdata['id'] ])) : ?>
                    <div class="lcwpd_lic_details">
                        <p>
                            <i title="Envato Username">
                                <span class="dashicons dashicons-admin-users"></span> <?php echo $licenses[ $pdata['id'] ]['user'] ?>
                            </i>
                            <i>
                                <span class="dashicons dashicons-awards"></span> <?php echo ucfirst($licenses[ $pdata['id'] ]['type']) ?> license
                                <?php 
                                if($licenses[ $pdata['id'] ]['expir']) {
                                    echo '('. lcwpd_licenses::human_lic_expir_remaining_time($licenses[ $pdata['id'] ]['expir']) .')';        
                                }
                                ?>
                            </i>
                        </p>
                        <p>
                            <label><?php echo lcwpd_licenses::human_support_remaining_time($licenses[ $pdata['id'] ]['set'], true) ?></label>
                            <a href="<?php echo esc_attr($pdata['ren_supp_link']) ?>" target="_blank">
                                <button type="button" name="lcwpd_extend_support_btn" class="button-secondary">
                                    <span class="dashicons dashicons-cart"></span>
                                    <span>Extend it</span> 
                                </button>    
                            </a>
                        </p>
                    </div>
                <?php endif; ?>
                
            </li>
        <?php endforeach; ?>
    </ul>
    
    
    
    <?php
    $missing_prods = lcwpd_licenses::missing_products();
    if(!empty($missing_prods)) :
        echo '
        <br/><br/><br/>
        <h3>Not Enabled Yet</h3>
        
        <ul class="lcwpd_prod_list lcwpd_missing_prods">';
        
            foreach($missing_prods as $pdata) :
        ?> 
            <li class="lcwpd_prod" data-prod-id="<?php echo esc_attr($pdata['id']) ?>">
                <div class="lcwpd_prod_firstblock">
                    <span>
                        <img src="<?php echo $baseurl ?>/assets/img/product_logos/<?php echo esc_attr($pdata['slug']) ?>.svg" alt="<?php echo esc_attr($pdata['name']) ?>" />
                    </span>

                    <div>
                        <h4><?php echo $pdata['name'] ?></h4>
                        <a href="<?php echo esc_attr($pdata['lc_link']) ?>" target="_blank">
                            <button type="button" name="lcwpd_knowmore_btn" class="button-secondary">
                                <span>Know more</span>
                                <span class="dashicons dashicons-arrow-right"></span>
                            </button>    
                        </a>
                    </div>
                </div>
            </li>
        <?php
            endforeach;
    
        echo '</ul>';
    endif;
    ?>
</div>




<?php 
// welcome lightbox - code
$prod_welcome_code = '';
if(isset($_GET['prod_welcome'])) {
    
    foreach($GLOBALS['lcwpd_products'] as $prod_path => $pdata) {
        if($_GET['prod_welcome'] == $pdata['slug']) {
            $pwc_pdata = $pdata;    
        }
    }
    
    $prod_welcome_code = "
    <div class='lcwpd_prod_welcome_wrap'>
        <img src='". $baseurl ."/assets/img/product_logos/". esc_attr($pwc_pdata['slug']) .".svg' />
        
        <h3>Thanks for choosing ". $pwc_pdata['name'] ."!</h3>
        <h5>You can get started in minutes checking the <a href='". $pwc_pdata['doc_link'] ."' target='_blank'>official documentation</a></h5>
        
        <button class='button-secondary' onclick='window.lcwpm_close()'>
            <span class='dashicons dashicons-thumbs-up'></span>
            Let's start!
        </button>
    </div>";
    
    $prod_welcome_code = apply_filters('lcwpd_prod_welcome_code', $prod_welcome_code, $_GET['prod_welcome']); // last attr is slug
}
?>




<script type="text/javascript">
(function() { 
    "use strict";    

    const nonce = '<?php echo wp_create_nonce('lcwpd_nonce') ?>';
    
    
    /* dunno why, but must block also form submit */
    document.querySelectorAll('.lcwpd_prod form').forEach(function(el) {
        el.addEventListener('submit', function(e) {
            e.preventDefault();
            return false;
        });
    });
    
    
    /* submit license validation with enter key */
    document.querySelectorAll('input[name="lcwpd_prod_token"]').forEach(function(el) {
        el.onkeyup = (e) => {
            
            if(e.keyCode === 13 || e.which === 13) { 
                e.preventDefault();
                el.parentNode.querySelector('input[name="lcwpd_prod_activation_btn"]').click();
                return false;
            }
        }
    });
    

    // validate license token
    document.querySelectorAll('input[name="lcwpd_prod_activation_btn"]').forEach(function(el) {
        el.addEventListener('click', function(e) {
        
            const $btn      = e.target,
                  $wrap     = recursive_parent($btn, '.lcwpd_prod'),
                  prod_id   = $wrap.getAttribute('data-prod-id'),
                  $field    = $wrap.querySelector('input[type="text"]'), 
                  val       = $field.value.trim();
            
            if(!val || $btn.classList.contains('lcwpd_blinking_btn')) {
                return false;    
            }
            
            if(val.length != 32) {
                lc_wp_popup_message('error', "Validation token must be 32 characters long");
                return false;    
            }
            
            $field.disabled = true;
            $btn.classList.add('lcwpd_blinking_btn');
            
            const crypted_params = encrypt_string(JSON.stringify({
                prod_id : prod_id,
                domain  : window.location.hostname.replace('www.', '').replace('WWW.', ''),
                token   : val,
                unicum  : Math.random(),
            }));
            
            
            fetch(ajaxurl, {
                method: 'POST',
                credentials: 'same-origin',
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded',
                    'Cache-Control': 'no-cache',
                },
                body: new URLSearchParams({
                    action      : 'lcwpd_validate_domain_token',
                    data        : crypted_params,
                    lcwpd_nonce : nonce,
                })
            })
            .then(response => response.json())
            .then(function(resp) {

                if(resp.status == 'error') {
                    lc_wp_popup_message('error', resp.message);    
                }
                else {
                    lc_wp_popup_message('success', resp.message);      
                    setTimeout(() => {
                        window.location.reload();
                    }, 1150);
                }
                
                $field.disabled = false;
                $btn.classList.remove('lcwpd_blinking_btn');
            })
            .catch(function (err) {
                console.error(err);
                lc_wp_popup_message('error', 'Error performing the operation. Please try again');
                
                $field.disabled = false;
                $btn.classList.remove('lcwpd_blinking_btn');
            });
        });
    });
    
    
    
    /* show change token form */
    document.querySelectorAll('input[name="lcwpd_change_token_btn"]').forEach(function(el) {
        el.addEventListener('click', function(e) {
        
            const $wrap = recursive_parent(e.target, '.lcwpd_prod');
            $wrap.querySelector('.lcwpd_inserted_token_form').remove();
            $wrap.querySelector('.lcwpd_insert_token_form').classList.remove('lcwpd_displaynone');
        });
    });
    
        
        
    /* encrypt a string */
    const encrypt_string = function(str) {
        let encoded = "";
        for (let i=0; i<str.length;i++) {
            let a = str.charCodeAt(i);
            let b = a ^ 88;
            encoded = encoded+String.fromCharCode(b);
        }
        return encoded;
    };
    
    
    
    
    /*/////////////////////////////////////////////////////////////////*/
    
    

    
    const modal_closing_code = '<span class="dashicons dashicons-no-alt lcwpd_close_modal"></span>';
    let changelogs = {}; // fetched changelog cache
    

    // trigger changelog popup display
    document.addEventListener("DOMContentLoaded", function(event) {
        document.querySelectorAll('.lcwpd_changelog_trigger').forEach(function(el) {
            
            el.addEventListener('click', function(e) {
                const slug = recursive_parent(e.target, '.lcwpd_prod').getAttribute('data-prod-slug');
                
                const loader = `
                <div class="lcwpd_modal_contents">
                    <h2 class="lcwpd_modal_loader">
                        <img src="<?php echo admin_url() ?>/images/spinner-2x.gif" alt="loading" class="aligncenter" />    
                    </h2>
                </div>`;
                
                lc_wp_popup_message('modal', loader + modal_closing_code);
                document.body.style.overflow = 'hidden';
                
                document.querySelector('.lcwpd_close_modal').addEventListener('click', function(e) {
                    close_lc_popup_modal();       
                });
                
                if(typeof(changelogs[slug]) != 'undefined') {
                    document.querySelector('.lcwpd_modal_contents').innerHTML = changelogs[slug];     
                } else {
                    fetch_remote_changelog(slug);        
                }
            });
        });
        
        
        
        <?php
        // opening a changelog while entering the dashboard with right parameter
        if(isset($_GET['prod_cl'])) :
        ?>
            
        const spc_trig_selector = document.querySelector('.lcwpd_prod[data-prod-slug="<?php echo esc_attr($_GET['prod_cl']) ?>"] .lcwpd_changelog_trigger');
        if(spc_trig_selector) {
            spc_trig_selector.click();    
        }
        
        <?php endif; ?>
    });
    
    
    
    // remotely fetch product changelog 
    const fetch_remote_changelog = async (prod_slug) => {
        
        const on_upd_prod = '<?php echo (isset($_GET['prod_updated'])) ? $_GET['prod_cl'] : '' ?>';
        
        fetch(ajaxurl, {
            method: 'POST',
            credentials: 'same-origin',
            headers: {
                'Content-Type': 'application/x-www-form-urlencoded',
                'Cache-Control': 'no-cache',
            },
            body: new URLSearchParams({
                action      : 'lcwpd_get_remote_changelog',
                prod_slug   : prod_slug,
                lcwpd_nonce : nonce
            })
        })
        .then(response => response.text())
        .then(function(html) {
            
            const prod_name = document.querySelector('.lcwpd_prod[data-prod-slug="'+ prod_slug +'"] h4').innerText.trim(),
                  prod_img  = "<img src='<?php echo $baseurl ?>/assets/img/product_logos/"+ prod_slug +".svg' class='lcwpd_changelog_img' />";
            
            let pre = 
                '<div class="lcwpd_cl_popup_head">';
            
            // pre-text in case of plugin update 
            if(on_upd_prod == prod_slug) {
                pre += `
                ${ prod_img }
                <div>
                    <h3 class="lcwpd_changelog_title">${ prod_name } successfully updated!</h3>
                    <h4 class="lcwpd_changelog_title">In the following changelog you can see what changed:</h4>
                </div>`;
            }
            
            // normal pre-text
            else {
                pre += prod_img +'<h3 class="lcwpd_changelog_title">'+ prod_name +' changelog</h3>';
            }
            
            pre += '</div>';
            
            changelogs[prod_slug] = pre + html;
            document.querySelector('.lcwpd_modal_contents').innerHTML = changelogs[prod_slug];     
        })
        .catch(function (err) {
            console.error(err);
            alert('there was an error fetching the changelog');
        });
    };
        
    
    
    
    // how to get token? popup
    document.querySelectorAll('.lcwpd_how_get_token').forEach(function(el) {   
        el.addEventListener('click', function(e) {
            
            const contents = `
            <ol class="lcwpd_howto_popup_list">
                <li>Activation tokens are given by <a href="v" target="_blank">LC Lienses Hub</a> and are strictly linked to a domain and a purchase code.<br/>Then, as first, login into your Licenses Hub account (or register if you don't have an account yet)</li>

                <li>Select the product section the you want to address and a list of all available products will be shown</li>

                <li>Each product block will list your licenses. Unless you registered it on the old updater (<em>before March 2022</em>) you need to add it to the Licenses Hub: specifying the purchase code, target domain and optionally the staging domain
    
                <img src="<?php echo $baseurl ?>/assets/img/howto/lclh_add_license.png" /></li>

                <li>Once added, the page will refresh showing you a specific token for each domain. Copy and use them in this dashboard
    
                <img src="<?php echo $baseurl ?>/assets/img/howto/lclh_domain_tokens.png" /></li>
            </ol>`;
            
            lc_wp_popup_message('modal', contents + modal_closing_code);
            document.body.style.overflow = 'hidden';

            document.querySelector('.lcwpd_close_modal').addEventListener('click', function(e) {
                close_lc_popup_modal();       
            });
        });
    });
    
    
    
    
    
    
    <?php if(!empty($prod_welcome_code)) : ?>
    // plugin welcome popup
    document.addEventListener("DOMContentLoaded", function(event) {
        lc_wp_popup_message('modal', `<?php echo $prod_welcome_code ?>`);
    });
    <?php endif; ?>
    
       
    

    // close popup on ESC key press
    document.onkeydown = function(evt) {
        evt = evt || window.event;
        let isEscape = false;
        
        if("key" in evt) {
            isEscape = (evt.key === "Escape" || evt.key === "Esc");
        } else {
            isEscape = (evt.keyCode === 27);
        }
        
        if(isEscape && document.querySelector('.lcwpm_modal')) {
            close_lc_popup_modal();    
        }
    };
    
    
    
    // close lc popup modal
    const close_lc_popup_modal = () => {
        window.lcwpm_close();
        document.body.style.overflow = 'auto';
    };
    
    
    
    /*/////////////////////////////////////////////////////////////////*/
    
    
    
    // pure-JS equivalent to parents()
    const recursive_parent = (element, target) => {
        let node = element;
        
        while(node.parentNode != null && !node.matches(target) ) {
            node = node.parentNode;
        }
        return node;
    };
    
})();
</script>